// CubesDoc.cpp : implementation of the CCubesDoc class
//

#include "stdafx.h"
#include "Cubes.h"

#include "CubesDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCubesDoc

IMPLEMENT_DYNCREATE(CCubesDoc, CDocument)

BEGIN_MESSAGE_MAP(CCubesDoc, CDocument)
	//{{AFX_MSG_MAP(CCubesDoc)
	ON_COMMAND(ID_TEXT, OnText)
	ON_COMMAND(IDD_DIALOG2, OnVisibility)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_SEARCH, OnSearch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCubesDoc construction/destruction

CCubesDoc::CCubesDoc()
{
	// TODO: add one-time construction code here

}

CCubesDoc::~CCubesDoc()
{
}

BOOL CCubesDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCubesDoc serialization

void CCubesDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCubesDoc diagnostics

#ifdef _DEBUG
void CCubesDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCubesDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCubesDoc commands
extern void openCommandFile( const char* fileName );
extern void saveLine( const char* line );
#include "log.h"
BOOL CCubesDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	log_message( "got on open document" );
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	openCommandFile( lpszPathName );

	return TRUE;
}
#include "TextDialog.h"
extern void sendLabel( CString s );
void CCubesDoc::OnText() 
{
	CTextDialog aboutDlg;
	if ( aboutDlg.DoModal() == IDOK ) {
		sendLabel( aboutDlg.m_label );
	}
}

#include "VisibilityDialog.h"
void CCubesDoc::OnVisibility() 
{
	VisibilityDialog visibilityDlg;
	if ( visibilityDlg.DoModal() == IDOK ) {	
		if ( visibilityDlg.IsDlgButtonChecked( IDC_CHECK24 )) {
			exit( 0 );
		}
	}
}

#include "log.h"
extern void saveSession( const char* filename );
void CCubesDoc::OnFileSaveAs() 
{
	CFileDialog saveState( false );
	if ( saveState.DoModal() == IDOK ) {
		// we got a file name
		CString filename = saveState.GetPathName();
		log_message1( "filename is:", LPCTSTR( filename ));
		saveSession( LPCTSTR( filename ));
	}
}

void CCubesDoc::OnFileOpen() 
{
	//log_message( "OK, I AM IN CCubesDoc OnFileOpen" );
	CFileDialog openFile( true );
	//log_message( "about to do the modal thing" );
	if ( openFile.DoModal() == IDOK ) {
		//log_message( "it was IDOK" );
		CString filename = openFile.GetPathName();
		//log_message( "I am callg openCommandFile" );
		openCommandFile( filename.GetBuffer(300) );
	} else {
		//log_message( "Hmm, got an unexpected return value" );
	}

	//log_message( "onFileOpen returned" );
}

#include "SearchDialog.h"
extern void searchFor( CString s );
extern void complexSearch( CString s );

void CCubesDoc::OnSearch() 
{
	SearchDialog aboutDlg;
	if ( aboutDlg.DoModal() == IDOK ) {
		searchFor( aboutDlg.m_searchFor );
	}	
}
